import os
import csv
import urllib
from urllib.request import Request

import requests
from urllib3.exceptions import NewConnectionError, MaxRetryError
import itertools


def build_request():
    with open(f"{os.getcwd()}/reestr.csv", newline="") as file:
        rfile = csv.DictReader(file)
        failed = []
        for row in itertools.islice(rfile, 2000, 2657): # here random
            book_url = row.get("sourceLink")
            book_id = row.get("id")
            import ssl
            ssl._create_default_https_context = ssl._create_unverified_context
            try:
                opener = urllib.request.build_opener()
                opener.addheaders = [("User-Agent", "Mozilla/5.0 (X11; Linux x86_64; rv: 120.0) Gecko / 20100101 Firefox / 120.0")]
                urllib.request.install_opener(opener)
                urllib.request.urlretrieve(f"https://minfin.gov.ru/{book_url}", f"{book_id}.pdf")
            except (Exception, urllib.request.HTTPError, MaxRetryError,
                    NewConnectionError, requests.exceptions.ProxyError) as Error:
                with open("logs.txt", "w") as error_file:
                    failed.append(book_id)
                    error_file.write(f"failed: {failed}")
                    print(Error)
                    continue
        print("Done")


if __name__ == "__main__":
    build_request()

